;/*
;* rtc32.inc
;*
;*  Created: 21.02.2015 20:26:03
;*   Author: Dominik
;*/ 

.IFNDEF RTC32_INCLUDE
.SET RTC32_INCLUDE = 1

	.IFNDEF RTC32_BASE
		.EQU RTC32_BASE = 0x0420
	.ENDIF

	RTC32_ENABLE:
	PUSH R16
		; ENABLE RTC32
		LDI R16, 0x01
		STS RTC32_BASE, R16
	POP R16
	RET

	RTC32_DISABLE:
	PUSH R16
		; DISABLE RTC32
		LDI R16, 0x00
		STS RTC32_BASE, R16
	POP R16
	RET

	RTC32_SET_PER: ; R16:17:18:R19 = Reriod Value
		RCALL RTC32_WAIT_SYNCBUSY
		STS RTC32_BASE+0x08, R19
		STS RTC32_BASE+0x09, R18
		STS RTC32_BASE+0x0A, R17
		STS RTC32_BASE+0x0B, R16
	RET

	RTC32_SET_CNT: ; R16:17:18:R19 = Counter Value
		RCALL RTC32_WAIT_SYNCBUSY
		STS RTC32_BASE+0x04, R19
		STS RTC32_BASE+0x05, R18
		STS RTC32_BASE+0x06, R17
		STS RTC32_BASE+0x07, R16
	RET

	RTC32_SET_COMP: ; R16:17:18:R19 = Compare Value
		RCALL RTC32_WAIT_SYNCBUSY
		STS RTC32_BASE+0x0C, R19
		STS RTC32_BASE+0x0D, R18
		STS RTC32_BASE+0x0E, R17
		STS RTC32_BASE+0x0F, R16
	RET

	RTC32_RESET_CNT:
	PUSH R16
		RCALL RTC32_WAIT_SYNCBUSY
		LDI R16, 0x00
		STS RTC32_BASE+0x04, R16
		STS RTC32_BASE+0x05, R16
		STS RTC32_BASE+0x06, R16
		STS RTC32_BASE+0x07, R16
	POP R16
	RET

	RTC32_WAIT_SYNCBUSY:
	PUSH R16
		RTC32_WAIT_SYNCBUSY_LOOP:
			LDS R16, (RTC32_BASE+0x01)
			SBRC R16, 0
		RJMP RTC32_WAIT_SYNCBUSY_LOOP
	POP R16
	RET

	RTC32_CLR_IF:
	PUSH R16
		LDI R16, 0b00000011
		STS (RTC32_BASE+0x03), R16
	POP R16
	RET

	RTC32_CLR_OVFIF:
	PUSH R16
		LDI R16, 0b00000001
		STS (RTC32_BASE+0x03), R16
	POP R16
	RET

	RTC32_CLR_COMPIF:
	PUSH R16
		LDI R16, 0b00000010
		STS (RTC32_BASE+0x03), R16
	POP R16
	RET

	RTC32_READ_COMPIF:
	PUSH R16
		CLR R0
		LDS R16, (RTC32_BASE+0x03)
		SBRC R16, 1
		INC R0
	POP R16
	RET

	RTC32_READ_OVFIF:
	PUSH R16
		CLR R0
		LDS R16, (RTC32_BASE+0x03)
		SBRC R16, 0
		INC R0	
	POP R16
	RET
.ENDIF